#include <stdio.h>
#include <string.h>
#include <stdlib.h>

//function to swap two pointers
void Swap(char **a, char **b) {
    char *temp;
    temp = *a;
    *a = *b;
    *b = temp;
}


void SelectionSort(char* arr[], int size) {
    int i, j;

    char *token1 = NULL;
    char *token2 = NULL;
    char temp1[200];
    char temp2[200];

    for (i = 0; i < size-1; i++) {
        //copies char array to new line for tokenizing
        strcpy(temp1, arr[i]);
        //gets name
        token1 = strtok(temp1, ",");
        for (j = i+1 ; j < size; j++) {
            strcpy(temp2, arr[j]);
            token2 = strtok(temp2, ",");
            if (strcmp(token1, token2) > 0) {
                Swap(&arr[i], &arr[j]);
                //swaps values of tokens
                *token1 = *token2;
            }
        }
    }
}
int ReadHurricanes(char* h[]){

    //Open the file
    FILE* inFile = fopen("/public/lab4/hurricanes.csv", "r");

    // Prints error if file not opened
    if( inFile == NULL  ) {
        perror("Error: ");
        return(-1);
  }

    int i = 0;
    do {
        h[i] = malloc(sizeof(char) * 200);
    } while (fgets(h[i++], 200, inFile) != NULL);
    --i;
    fclose(inFile);

    // returns length of array
    return i;
}

void PrintHurricanesFile(char* h[], int length){
    FILE* outFile = fopen("./out.txt", "w");
    char *result = NULL;

    fprintf(outFile, "Hurricanes in Florida with category and date\n");

    for (int i = 0; i < length; i++){

        result = strtok(h[i], ",");
        fprintf(outFile, "%-15s", result);

        strtok(NULL, " ");
        result = strtok(NULL, " ");
        fprintf(outFile, "%-4s", result);

        strtok(NULL, ",");
        result = strtok(NULL, ",");
        fprintf(outFile, "%s ", result);
        result = strtok(NULL, ",");
        fprintf(outFile, "%s", result);

    }
    fclose(outFile);

}


int main(void){
    char *hurricanes[100];
    int length;

    //calls to functions
    length = ReadHurricanes(hurricanes);
    SelectionSort(hurricanes, length);
    PrintHurricanesFile(hurricanes, length);

    return(0);
}
