#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "funcs.h"

void PrintClass(cs_class_t class){
    printf("%-34s%-12s%-25s%-5s%-5s%-10s\n", class.title, class.id, class.professor, class.seats, class.days, class.time);

}

void ClassNum(cs_class_t* classlist, int length, char input[]){
    printf("\n");
    for (int i = 0; i < length; i++){
        if (strcmp(classlist[i].id, input) == 0) {
            PrintClass(classlist[i]);
        }
    }
    printf("\n");
}

void ClassDay(cs_class_t* classlist, int length, char input[]){
    printf("\n");
    for (int i = 0; i < length; i++){
        if (strcmp(classlist[i].days, input) == 0) {
            PrintClass(classlist[i]);
        }

    }
    printf("\n");
}

void ClassProfessor(cs_class_t* classlist, int length, char input[]) {
    char temp[30];
    printf("\n");
    for (int i = 0; i < length; i++){
        // Do this to not tokenize original professor name
        strcpy(temp, classlist[i].professor);
        if (strcmp(strtok(temp, " "), input) == 0) {
            PrintClass(classlist[i]);
        }

    }
    printf("\n");
}

int MainMenu(cs_class_t* classlist, int listLength){

    char input[20];
    //For the CSCI and NUMBER
    char input2[20];

    while (1) {
        printf("Choices\n");
        printf("n - print class given number\n");
        printf("d - print all classes for a given day combo\n");
        printf("p - print all classes for a  given professor\n");
        printf("q - quit\n");
        scanf("%s", input);

        switch (*input) {
            case 'n':
                printf("Enter class number: ");
                scanf("%s %s", input, input2);
                //Combines input to one string
                strcat(strcat(input, " "), input2);
                ClassNum(classlist,listLength, input);
                break;
            case 'd':
                printf("Enter class days to print (MWF or TR): ");
                scanf("%s", input);
                printf("List of classes for days %s:\n", input);
                ClassDay(classlist, listLength, input);
                break;
            case 'p':
                printf("Enter Professor's Last Name: ");
                scanf("%s", input);
                printf("List of classes for Professor %s:\n", input);
                ClassProfessor(classlist,listLength, input);
                break;
            case 'q':
                return 0;
                break;
        }
    }
    return 0;
}
